-----------------------------------------------------------
-- Test Drive Unlimited 2 CAR/RIM/BIKE/BUILDING mesh script
-- for 3D STUDIO MAX. Made with 3DSMAX 9, script should
-- work on max 5+ too. Rotate everything by +90deg on
-- X axis after importing Some materals and normals will not be
-- correct. Made by vagos21. e-mail: vagos21@yahoo.com
-- 
-- Run the script and select the extracted bnk folder For the
-- first run, you might also want to let it convert all
-- the textures too. Wait for a few secs, and you're done!
-----------------------------------------------------------

struct objesctstable(name, offset)
struct materialstable(name, offset)
struct instancestable(name, offset, matrix, materialsoffset, meshname)
struct GEOM(name, numprims, prims = #() )
struct PRIM(vboffset, iboffset, numverts, numinds, amesh)
struct hierarchytable(name, offset, parent, parentoffset, level, matrix)

--hard coded vertex buffers...
xyz =                       #(2816,512,0,3072,5888,2816,4352,0,0,0,0,4160)
xyzUVJqq =               #(2817,512,0,3073,5888,2816,4352,0,0,0,0,4160)
xyzJqqcolor2 =           #(2817,513,0,3072,5888,2816,4352,0,0,0,0, 320)
xyzJqqcolor =            #(2817,513,0,3072,5888,2816,4352,0,0,0,0,4160)
xyzJqqcolor3 =           #(2817,513,0,3072,    0,     0,4352,0,0,0,0, 320)
xyzJqqcolorUV2 =       #(2817,513,0,3073,     0,     0,4352,0,0,0,0, 320)
xyzJqqcolorUV3 =       #(2817,513,0,3073,     0,     0,4352,0,0,0,0,2112)
xyzUVJqqcolor2 =       #(2817,513,0,3073,     0,     0,4352,0,0,0,0,4160)

xyzJqqcolorUV =         #(2817,513,0,3073,5888,2816,4352,0,0,0,0, 320)
xyzUVJqqcolor =         #(2817,513,0,3073,5888,2816,4352,0,0,0,0,4160)
xyzJqqcolorUVqqqq =  #(2817,513,0,3073,5889,2817,4352,0,0,0,0, 320)
xyzUVJqqcolorqqqq =  #(2817,513,0,3073,5889,2817,4352,0,0,0,0,4160)
xyzUVUVJqqcolor2 =    #(2817,513,0,3074,    0,     0,4352,0,0,0,0,4160)
xyzJqqcolorUVUV =     #(2817,513,0,3074,5888,2816,4352,0,0,0,0, 320)
xyzJqqcolorUVUVqq =  #(2817,513,0,3074,5889,2816,4352,0,0,0,0, 320)
xyzUVUVJqqcolor =     #(2817,513,0,3074,5888,2816,4352,0,0,0,0,4160)
xyzJqqcolorUVqqqqqq=#(2817,513,0,3074,5889,2817,4352,0,0,0,0, 320)
xyzJqqcolorUVUVqqqq=#(2817,513,0,3074,5889,2817,4352,0,0,0,0, 320)
xyzUVqqJqqcolorqqqq=#(2817,513,0,3074,5889,2817,4352,0,0,0,0,4160)
xyzUVUVJqqcolorqqqq=#(2817,513,0,3074,5889,2817,4352,0,0,0,0,4160)
xyzUVqqqqJqqcolor =  #(2817,513,0,3075,5888,2816,4352,0,0,0,0,4160)
xyzUVqJqqcolorqq =  #(2817,513,0,3073,5888,2816,4353,4865,0,0,0,576)

--materials array
matsarr = #()
--meshes array
geoms = #()

macroScript TDU category:"myscripts"
(
	undo off

	modelpath = getSavePath caption:"Select extracted TDU model folder"
	--commontexpath = getSavePath caption:"Select -Common_car- TDU folder"
	
	print modelpath
	
	convertTex = (queryBox "Do you want to convert all Textures in the folder?" title: "Texture Conversion" )
	if convertTex then(convertTextures modelpath) --convert all textures in folder to DDS

	loadMeshes modelpath --load all meshes (3DG file)
	loadMaterials modelpath --load all materials (2DM file)
	buildScene modelpath--build scene from materials and meshes (load 3DD file)

	--finally rotate scene by 90degrees
	try
		(
		select $SCENE01
		rotate $ (eulerangles 90 0 0)
	)catch()


	
) --main script


fn buildScene filename =
(

	--open file
	path = getFiles (filename+"\\*.3dd")
	f = fopen path[1]  "rb"
	
	--jump MBNA
	fseek f 24 #seek_set
	MBNAsize = readlong f #unsigned
	fseek f (MBNAsize - 12) #seek_cur
	--jump OBJA
	fseek f 8 #seek_cur
	OBJAsize = readlong f #unsigned
	fseek f (OBJAsize - 12) #seek_cur
	--read INSA table
	fseek f 8 #seek_cur
	INSAsize = readlong f #unsigned
	fseek f 16 #seek_cur
	insanum = ((readlong f #unsigned)-16) / 16
	instances = #(insanum) --insa array
	for i=1 to insanum do
	(
		aname = ""
		for w=1 to 8 do (aname += (bit.intasChar(readByte f #unsigned)))
		aoffset = readlong f #unsigned
		fseek f 4 #seek_cur
		instances[i] = instancestable aname aoffset
	)
	
	--read corresponding GEOM and material names, also transformation matrix
	for i=1 to insanum do
	(	
		fseek f instances[i].offset #seek_set
		--read transformation matrix
		fseek f 16 #seek_cur
		transMatrix= matrix3 0
		transMatrix.row1=[readfloat f, readfloat f, readfloat f]
		fseek f 4 #seek_cur
		transMatrix.row2=[readfloat f, readfloat f, readfloat f]
		fseek f 4 #seek_cur
		transMatrix.row3=[readfloat f, readfloat f, readfloat f]
		fseek f 4 #seek_cur
		transMatrix.row4=[readfloat f, readfloat f, readfloat f]
		fseek f 4 #seek_cur
		--read material offset
		fseek f 4 #seek_cur
		amatoffset = readlong f #unsigned
		--read mesh name offset
		fseek f 8 #seek_cur
		meshoffset = readlong f #unsigned
		if (meshoffset == 0) then --it's a dummy
		(
			adummy = dummy name:(instances[i].name)
			adummy.boxsize = [0.1,0.1,0.1]
		)
		else
		(
			--read mesh name
			fseek f (meshoffset) #seek_set
			ameshname = ""
			for w=1 to 8 do (ameshname += (bit.intasChar(readByte f #unsigned)))
			--add info to instances table
			instances[i].meshname = ameshname
			instances[i].materialsoffset = amatoffset
	--print ameshname
		)
		instances[i].matrix = transMatrix
	)

	--clone meshes according to names and assign materials to primitives
	for i=1 to insanum do
	(
		for j=1 to geoms.count do
		(
			if (instances[i].meshname == geoms[j].name ) then -- we found an existing mesh
			(
				--first mesh is first primitive
				newmesh = copy geoms[j].prims[1].amesh
				--give name to new mesh 
				newmesh.Name = (instances[i].name)
				--goto materials list
				fseek f (instances[i].materialsoffset+16) #seek_set
				--find material
				amatname = ""
				for w=1 to 16 do (amatname += (bit.intasChar(readByte f #unsigned)))
				for mat=1 to matsarr.count do
				(
					if (amatname == matsarr[mat].name) then
					(
						--assign material to clone
						newmesh.material = matsarr[mat]
						exit
					)		
				)
				
				if geoms[j].numprims>1 then --attach the rest of the primitives
				(
					for k=2 to geoms[j].numprims do
					(
						amesh = copy geoms[j].prims[k].amesh
						--find material
						amatname = ""
						for w=1 to 16 do (amatname += (bit.intasChar(readByte f #unsigned)))
						for mat=1 to matsarr.count do
						(
							if (amatname == matsarr[mat].name) then
							(
								--assign material to clone
								amesh.material = matsarr[mat]
								exit
							)
						)
						meshop.attach newmesh amesh attachMat: #MatToID
					)
				)
				exit --go to next instance
			)
		)
	)
	
	
	--delete ALL previous meshes used!!!
	for i=1 to geoms.count do
	(
		for j=1 to geoms[i].numprims do
		(
			delete geoms[i].prims[j].amesh
		)
	)
	--clean up arrays
	for i=1 to geoms.count do (deleteItem geoms 1)
	for i=1 to matsarr.count do (deleteItem matsarr 1)
	
	
	hierarchy = #() --hierarchy table
	--build scene hierarchy
	fseek f (MBNAsize+OBJAsize+INSAsize+16) #seek_set
	type = "" --read if HIEA exists
	for w=1 to 4 do (type += (bit.intasChar(readByte f #unsigned)))
	if (type == "HIEA") then --scene has hierarchy
	(
		fseek f 28 #seek_cur --go to hierarchy table
		--read hierarchy table and build structure
		for i=1 to insanum do
		(
			aname = ""
			for w=1 to 8 do (aname += (bit.intasChar(readByte f #unsigned)))
			aoffset = readlong f #unsigned
			fseek f 4 #seek_cur
			ahiea = hierarchytable aname aoffset
			append hierarchy ahiea
		)
		for i=1 to insanum do --find parent name
		(
			fseek f (hierarchy[i].offset+28) #seek_set
			parentoffset=readlong f #unsigned
			hierarchy[i].parentoffset = parentoffset
			hierarchy[i].matrix = instances[i].matrix
			for j=1 to insanum do
			(
				if (hierarchy[j].offset==parentoffset) then (hierarchy[i].parent=hierarchy[j].name; exit)
			)		
		)
		--sort hierarchy array by parent offset (stonesort :P)
		for i = 1 to insanum-1 do
		(
			for j = i+1 to insanum do
    		(
      			if (hierarchy[i].parentoffset > hierarchy[j].parentoffset) then
      			(
        			temphierarchy = hierarchy[j];
        			hierarchy[j] = hierarchy[i];
        			hierarchy[i] = temphierarchy;
      			)
    		)
		)
		--find level for each node
		hierarchy[1].level=1
		for i=2 to insanum do
		(
			for j=1 to i do
			(
				if (hierarchy[i].parent == hierarchy[j].name) then ( hierarchy[i].level = hierarchy[j].level+1 ;exit)
			)
		)
		--find max number of levels
		maxlevel=1
		for i=1 to insanum do
		(
			if (hierarchy[i].level > maxlevel) then (maxlevel = hierarchy[i].level)
		)
		--apply hierarchy structure to loaded nodes
		for lev=maxlevel to 2 by -1 do
		(
			--transform every object in that level
			for i=1 to insanum do
			(
				if (hierarchy[i].level==lev) then
				(
					(getNodeByName hierarchy[i].name).transform = hierarchy[i].matrix
				)	
			)
			--add current level object to parent
			for i=1 to insanum do
			(
				if (hierarchy[i].level==lev) then
				(
					attachObjects (getNodeByName hierarchy[i].parent) (getNodeByName hierarchy[i].name) move:false
				)
			)
		)
		
	) --hierarchy if

	
	--close file
	fclose f
	
	print "Scene created!"
) --buildScene


fn loadMaterials filename =
(
	--open file
	path = getFiles (filename+"\\*.2dm")
	f = fopen path[1]  "rb"
	
	--read materials table
	fseek f 44 #seek_set
	materialsnum = ((readlong f #unsigned)-16) / 16
	print (materialsnum as string+" materials found.")
	materials = #(materialsnum)
	for i=1 to materialsnum do
	(
		aname = ""
		for w=1 to 8 do (aname += (bit.intasChar(readByte f #unsigned)))
		aoffset = readlong f #unsigned
		fseek f 4 #seek_cur
		materials[i] = materialstable aname aoffset
	--print materials[i]
	)
	
	--apo to MAT
	for i=1 to materialsnum do
	(
		fseek f materials[i].offset #seek_set
		
		--read number of textures used
		fseek f 268 #seek_cur
		numproperties = readshort f #unsigned
		fseek f 2 #seek_cur
		
		--print ("Loading Material: "+materials[i].name)
		amaterial = standard showInViewport:true Name: materials[i].name
		
		for j=1 to numproperties do
		(
			paramType = ""
			for w=1 to 8 do (paramType += (bit.intasChar(readByte f #unsigned)))
			paramValue = ""
			for w=1 to 8 do (paramValue += (bit.intasChar(readByte f #unsigned)))
			fseek f 16 #seek_cur
			

			if (paramValue.count > 0) then
			(
				case substring paramType 3 (paramType.count-2) of
				(
					"TAIL": --diffuse (UV1)
						(	
							adiffusemap = Bitmaptexture fileName: (filename+"/maps/"+paramValue+".dds")
							amaterial.diffuseMap=(adiffusemap)
							--print ("    DIFFUSE MAP: "+adiffusemap.filename)
						)
					"RMAL": --normal
						(
							anormalmap = Bitmaptexture fileName: (filename+"/maps/"+paramValue+".dds")
							amaterial.bumpMap=(anormalmap)
							--print ("    NORMAL MAP: "+anormalmap.filename)
						)				
					"OSS": --gloss
						(
							aglossmap = Bitmaptexture fileName: (filename+"/maps/"+paramValue+".dds")
							amaterial.specularLevelMap =(aglossmap )
							--print ("    GLOSS MAP: "+aglossmap.filename)
						)
					"FLECTI": --reflection
						()
					"XLIGHT": --tex light
						()
					"OSSLIG": --gloss light
						()
					"TAIL2": --texture2 (UV2)
						()
					"ADOW": --shadow
						()
					"LOR": --color
						()
				)
			)
		)
		
		amaterial.twoSided = on	
		amaterial.ambient = color 0 0 0
		amaterial.Diffuse = color 128 128 128
		amaterial.Specular = color 255 255 255
		--append loaded material to materials array
		append matsarr amaterial
	)

	print "Materials Loaded!"
	--close materials file
	fclose f
) --loadMaterials


fn loadMeshes filename =
(
	--open file
	path = getFiles (filename+"\\*.3dg")
	f = fopen path[1]  "rb"
	
	--read number of meshes	
	fseek f 44 #seek_set
	meshesnum = ((readlong f #unsigned)-16) / 16

	--read objects table
	objects = #(meshesnum)
	for i=1 to meshesnum do
	(
		aname = ""
		for w=1 to 8 do (aname += (bit.intasChar(readByte f #unsigned)))
		aoffset = readlong f #unsigned
		fseek f 4 #seek_cur
		objects[i] = objesctstable aname aoffset
	)


	--read GEOMS
	for i=1 to meshesnum do
	(
		primarr = #()
		fseek f (objects[i].offset + 8) #seek_set
		numprims = ((readlong f #unsigned)-16)/80
		fseek f 4 #seek_cur
		for p=1 to numprims do 
		(
				fseek f 16 #seek_cur
				iboffset = readlong f #unsigned
				vboffset = readlong f #unsigned
				fseek f 20 #seek_cur
				numverts = readlong f #unsigned
				fseek f 8 #seek_cur
				numinds = readlong f #unsigned
				fseek f 20 #seek_cur --jump remaining bytes
				aprim = PRIM vboffset iboffset numverts numinds
				append primarr aprim
		)
		ageom = GEOM objects[i].name numprims primarr
--print ageom
		append geoms ageom
	)

	--read primitives as meshes and attach them together in a GEOM
	for i=1 to meshesnum do
	(
		for j=1 to geoms[i].numprims do
		(
			iarr = #() --indices array
			farr = #() --faces array
			varr = #() --vertex positions array
			UVWarr = #() --vertex UV coords array
			fvfarr = #() --my FVFtype recognition shorts array
			
			--go to vertex buffer
			fseek f geoms[i].prims[j].vboffset #seek_set
			
			--jump a few bytes
			fseek f 22 #seek_cur
			--read FVFtype array
			for inp = 1 to 12 do (
				fvfarr[inp] = readshort f
			)
			--recognize fvf type array
			result = getFVFtype fvfarr
			if (result == "UNKNOWNFVF") then
			(
				print ("unknown fvf for prim " + j as string + " of mesh " + i as string + ". contact script writer!")
			)else(
				--read and return vertices and UVs from each prim offset according to FVF
				case result of
				(
					"xyz": (readFVFxyz f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzJqqcolorUV": (readFVFxyzJqqcolorUV f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzJqqcolor": (readFVFxyzJqqcolor f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzJqqcolorUVqqqq": (readFVFxyzJqqcolorUVqqqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVqqJqqcolorqqqq": (readFVFxyzUVqqJqqcolorqqqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVqqqqJqqcolor": (readFVFxyzUVqqqqJqqcolor f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVJqqcolor": (readFVFxyzUVJqqcolor f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)				
					"xyzJqqcolorUVqqqqqq": (readFVFxyzJqqcolorUVqqqqqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)				
					"xyzJqqcolorUVUV": (readFVFxyzJqqcolorUVUV f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)	
					"xyzJqqcolorUVUVqq":(readFVFxyzJqqcolorUVUVqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVUVJqqcolor":(readFVFxyzUVUVJqqcolor f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVJqq":(readFVFxyzUVJqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzJqqcolorUVUVqqqq":(readFVFxyzJqqcolorUVUVqqqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVUVJqqcolorqqqq":(readFVFxyzUVUVJqqcolorqqqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
					"xyzUVqJqqcolorqq":(readFVFxyzUVqJqqcolorqq f geoms[i].prims[j].vboffset geoms[i].prims[j].numverts varr UVWarr)
				)
			
				--read indices array
				fseek f geoms[i].prims[j].iboffset #seek_set
				fseek f 32 #seek_cur
				for v = 1 to geoms[i].prims[j].numinds do
				(
					aind = readshort f #unsigned
					append iarr (aind+1)
				)
			
				--build faces array from indices (convert strip to list)
				for ind = 1 to geoms[i].prims[j].numinds-2 do
				(
					fa = iarr[ind]
					fb = iarr[ind+1]
					fc = iarr[ind+2]		
					if ((fa!=fb)and(fa!=fc)and(fc!=fb)) then
					(
						if ( mod ind 2 == 0 ) then
						(
							aface = [fb,fa,fc]
						)else	(
						aface = [fa,fb,fc]								
						)
						append farr aface
					)
				)
				
				--build mesh from vertex and faces arrays		
				geoms[i].prims[j].amesh = mesh vertices:varr faces:farr name:geoms[i].name
				
				--apply uvw tex coords to mesh
				applyuvw geoms[i].prims[j].amesh UVWarr
			)
		)
	)
	
	--close 3DG file
	fclose f
	
	print "Meshes loaded!"
	
) --loadMeshes


fn convertTextures filename =
(
	--DDS HEADER info from http://msdn.microsoft.com/archive/default.asp?url=/archive/en-us/directx9_c/directx/graphics/reference/ddsfilereference/ddsfileformat.asp
	--DDS HEADER values from http://wiki.answers.com/Q/How_do_you_write_a_header_for_a_128x128x128_dds_volume_texture_file_with_no_mipmaps_and_does_it_have_to_be_written_in_binary
	
	--DDS header stuff
	DDSD_CAPS =			0x00000001
	DDSD_HEIGHT =		0x00000002
	DDSD_WIDTH =		0x00000004
	DDSD_PITCH =		0x00000008
	DDSD_PIXELFORMAT =	0x00001000
	DDSD_MIPMAPCOUNT =	0x00020000
	DDSD_MIPMAPCOUNT =	0x00020000
	DDSD_LINEARSIZE =	0x00080000
	DDSD_DEPTH =		0x00800000
	
	DDPF_ALPHAPIXELS =	0x00000001
	DDPF_FOURCC =		0x00000004
	DDPF_RGB =			0x00000040
	
	DDSCAPS_COMPLEX= 	0x00000008
	DDSCAPS_TEXTURE =	0x00001000
	DDSCAPS_MIPMAP =	0x00400000
	
	DDSCAPS2_CUBEMAP =			0x00000200
	DDSCAPS2_CUBEMAP_POSITIVEX=	0x00000400
	DDSCAPS2_CUBEMAP_NEGATIVEX=	0x00000800
	DDSCAPS2_CUBEMAP_POSITIVEY=	0x00001000
	DDSCAPS2_CUBEMAP_NEGATIVEY=	0x00002000
	DDSCAPS2_CUBEMAP_POSITIVEZ=	0x00004000
	DDSCAPS2_CUBEMAP_NEGATIVEZ=	0x00008000
	DDSCAPS2_VOLUME =			0x00200000
	
	DXT1 = 0x31545844
	DXT2 = 0x32545844
	DXT3 = 0x33545844
	DXT4 = 0x34545844
	DXT5 = 0x35545844
	
	ddsd = #(18) --dds description
	ddpf = #(8) --dds pixel format
	ddsCaps = #(4) --dds caps
	
	--open each texture
	for texfile in getFiles (filename+"\maps\*.2db") do
	(
		--read texture header stuff
		fin = fopen texfile "rb"
		--read texture size
		fseek fin 28 #seek_set
		texsize = (readlong fin #unsigned)-64
		--read texture name
		texname = ""
		for w=1 to 8 do (texname += (bit.intasChar(readByte fin #unsigned)))
		--read texture width and height
		width = readshort fin
		height = readshort fin
		fseek fin 2 #seek_cur
		--read number of mipmaps
		mipmapcount = readbyte fin #unsigned
		fseek fin 1 #seek_cur
		--read type of texture (DXT, uncompressed, cubemap etc...
		textype = readlong fin #unsigned
		fseek fin 28 #seek_cur
		--load texture data into array
		texdata = #(texsize)
		for i = 1 to texsize do texdata[i]= (readbyte fin #unsigned)
		--close source file
		fclose fin
		
		print ("Converting texture: "+texfile+".dds, Size: "+width as string+"x"+height as string+" mipmaps: "+mipmapcount as string)
		
		
		--build dds header from data
		dwMagic = 0x20534444 --"DDS"
		ddsd[1] = 124
		ddsd[3] = height
		ddsd[4] = width
		ddsd[6] = 32
		ddsd[7] = mipmapcount
		for i = 8 to 18 do ddsd[i]=0
		ddpf[1] = 32
		ddpf[4] = 32
		ddpf[5] = 0x00ff0000
		ddpf[6] = 0x0000ff00
		ddpf[7] = 0x000000ff
		ddpf[8] = 0xff000000
		ddsCaps[1] = DDSCAPS_MIPMAP
		ddsCaps[2] = 0
		ddsCaps[3] = 0
		ddsCaps[4] = 0
		--case specific header stuff
		case textype of
		(
			132:( --working
				--print "Texture format is DXT1 " --DXT1
				ddsd[2] = bit.or (bit.or (bit.or(bit.or (bit.or DDSD_CAPS DDSD_HEIGHT) DDSD_WIDTH) DDSD_PIXELFORMAT) DDSD_MIPMAPCOUNT) DDSD_LINEARSIZE
				ddpf[3] = DXT1
				ddsd[5] = texsize
				ddpf[2] = DDPF_FOURCC
				)
			136:( --working
				--print "Texture format is DXT5" --DXT5
				ddsd[2] = bit.or (bit.or (bit.or(bit.or (bit.or DDSD_CAPS DDSD_HEIGHT) DDSD_WIDTH) DDSD_PIXELFORMAT) DDSD_MIPMAPCOUNT) DDSD_LINEARSIZE
				ddpf[3] = DXT5
				ddsd[5] = texsize
				ddpf[2] = DDPF_FOURCC
				)
			144:(
				--print "Texture format is Uncompressed" --uncompressed RGBA!
				ddsd[2] = bit.or(bit.or(bit.or(bit.or (bit.or DDSD_CAPS DDSD_HEIGHT) DDSD_WIDTH) DDSD_PIXELFORMAT) DDSD_MIPMAPCOUNT) DDSD_PITCH
				ddpf[3] = 0
				ddsd[5] = width*4
				ddpf[2] = DDPF_RGB
				)
		)
	
		--open output file
		fout = fopen (texfile+".dds") "wb"
		--write header to file
		writelong fout dwMagic
		for i = 1 to 18 do (writeLong fout ddsd[i])
		for i = 1 to 8  do (writeLong fout ddpf[i])
		for i = 1 to 4  do (writeLong fout ddsCaps[i])
		writeLong fout 0
		--write texture data to file
		for i = 1 to texsize do (writeByte fout texdata[i] #unsigned)
		--flush output file
		fflush fout
		--close output file
		fclose fout
	)
	print "Texture Conversion Complete!"
) --convertTextures


fn applyuvw anode auvarray	= --applies UVW to node
(
	if (auvarray.count > 0) then (
		anode.numtverts = anode.numverts
		buildtvfaces anode
		for vi = 1 to anode.numverts do (
			settvert anode vi auvarray[vi]
		)				
		allfaces = #()
		for fi = 1 to anode.numfaces do (
			crtface = getface anode fi
			append allfaces crtface
		)
		for fi = 1 to anode.numfaces do (
			settvface anode fi allfaces[fi]
		)
	)
)

fn getFVFtype inputarray =
(
	result = "UNKNOWNFVF"
	
	if (inputarray[1] == xyz[1] and inputarray[2] == xyz[2] and inputarray[4] == xyz[4] and inputarray[5] == xyz[5] and inputarray[6] == xyz[6] and inputarray[7] == xyz[7] and inputarray[12] == xyz[12] ) then (
		result = "xyz"
	)
	
	if (inputarray[1] == xyzJqqcolorUV[1] and inputarray[2] == xyzJqqcolorUV[2] and inputarray[4] == xyzJqqcolorUV[4] and inputarray[5] == xyzJqqcolorUV[5] and inputarray[6] == xyzJqqcolorUV[6] and inputarray[7] == xyzJqqcolorUV[7] and inputarray[12] == xyzJqqcolorUV[12] ) then (
		result = "xyzJqqcolorUV"
	)
	
	if (inputarray[1] == xyzJqqcolor[1] and inputarray[2] == xyzJqqcolor[2] and inputarray[4] == xyzJqqcolor[4] and inputarray[5] == xyzJqqcolor[5] and inputarray[6] == xyzJqqcolor[6] and inputarray[7] == xyzJqqcolor[7] and inputarray[12] == xyzJqqcolor[12] ) then (
		result = "xyzJqqcolor"
	)

	if (inputarray[1] == xyzJqqcolorUVqqqq[1] and inputarray[2] == xyzJqqcolorUVqqqq[2] and inputarray[4] == xyzJqqcolorUVqqqq[4] and inputarray[5] == xyzJqqcolorUVqqqq[5] and inputarray[6] == xyzJqqcolorUVqqqq[6] and inputarray[7] == xyzJqqcolorUVqqqq[7] and inputarray[12] == xyzJqqcolorUVqqqq[12] ) then (
		result = "xyzJqqcolorUVqqqq"
	)

	if (inputarray[1] == xyzUVqqJqqcolorqqqq[1] and inputarray[2] == xyzUVqqJqqcolorqqqq[2] and inputarray[4] == xyzUVqqJqqcolorqqqq[4] and inputarray[5] == xyzUVqqJqqcolorqqqq[5] and inputarray[6] == xyzUVqqJqqcolorqqqq[6] and inputarray[7] == xyzUVqqJqqcolorqqqq[7] and inputarray[12] == xyzUVqqJqqcolorqqqq[12] ) then (
		result = "xyzUVqqJqqcolorqqqq"
	)

	if (inputarray[1] == xyzUVqqqqJqqcolor[1] and inputarray[2] == xyzUVqqqqJqqcolor[2] and inputarray[4] == xyzUVqqqqJqqcolor[4] and inputarray[5] == xyzUVqqqqJqqcolor[5] and inputarray[6] == xyzUVqqqqJqqcolor[6] and inputarray[7] == xyzUVqqqqJqqcolor[7] and inputarray[12] == xyzUVqqqqJqqcolor[12] ) then (
		result = "xyzUVqqqqJqqcolor"
	)

	if (inputarray[1] == xyzUVJqqcolor[1] and inputarray[2] == xyzUVJqqcolor[2] and inputarray[4] == xyzUVJqqcolor[4] and inputarray[5] == xyzUVJqqcolor[5] and inputarray[6] == xyzUVJqqcolor[6] and inputarray[7] == xyzUVJqqcolor[7] and inputarray[12] == xyzUVJqqcolor[12] ) then (
		result = "xyzUVJqqcolor"
	)
	
	if (inputarray[1] == xyzJqqcolorUVqqqqqq[1] and inputarray[2] == xyzJqqcolorUVqqqqqq[2] and inputarray[4] == xyzJqqcolorUVqqqqqq[4] and inputarray[5] == xyzJqqcolorUVqqqqqq[5] and inputarray[6] == xyzJqqcolorUVqqqqqq[6] and inputarray[7] == xyzJqqcolorUVqqqqqq[7] and inputarray[12] == xyzJqqcolorUVqqqqqq[12] ) then (
		result = "xyzJqqcolorUVqqqqqq"
	)
	
	if (inputarray[1] == xyzJqqcolorUVUV[1] and inputarray[2] == xyzJqqcolorUVUV[2] and inputarray[4] == xyzJqqcolorUVUV[4] and inputarray[5] == xyzJqqcolorUVUV[5] and inputarray[6] == xyzJqqcolorUVUV[6] and inputarray[7] == xyzJqqcolorUVUV[7] and inputarray[12] == xyzJqqcolorUVUV[12] ) then (
		result = "xyzJqqcolorUVUV"
	)
	
	if (inputarray[1] == xyzJqqcolorUVUVqq[1] and inputarray[2] == xyzJqqcolorUVUVqq[2] and inputarray[4] == xyzJqqcolorUVUVqq[4] and inputarray[5] == xyzJqqcolorUVUVqq[5] and inputarray[6] == xyzJqqcolorUVUVqq[6] and inputarray[7] == xyzJqqcolorUVUVqq[7] and inputarray[12] == xyzJqqcolorUVUVqq[12] ) then (
		result = "xyzJqqcolorUVUVqq"
	)
	
	if (inputarray[1] == xyzUVUVJqqcolor[1] and inputarray[2] == xyzUVUVJqqcolor[2] and inputarray[4] == xyzUVUVJqqcolor[4] and inputarray[5] == xyzUVUVJqqcolor[5] and inputarray[6] == xyzUVUVJqqcolor[6] and inputarray[7] == xyzUVUVJqqcolor[7] and inputarray[12] == xyzUVUVJqqcolor[12] ) then (
		result = "xyzUVUVJqqcolor"
	)
	
	if (inputarray[1] == xyzUVJqq[1] and inputarray[2] == xyzUVJqq[2] and inputarray[4] == xyzUVJqq[4] and inputarray[5] == xyzUVJqq[5] and inputarray[6] == xyzUVJqq[6] and inputarray[7] == xyzUVJqq[7] and inputarray[12] == xyzUVJqq[12] ) then (
		result = "xyzUVJqq"
	)	
	
	if (inputarray[1] == xyzJqqcolor2[1] and inputarray[2] == xyzJqqcolor2[2] and inputarray[4] == xyzJqqcolor2[4] and inputarray[5] == xyzJqqcolor2[5] and inputarray[6] == xyzJqqcolor2[6] and inputarray[7] == xyzJqqcolor2[7] and inputarray[12] == xyzJqqcolor2[12] ) then (
		result = "xyzJqqcolor"
	)
	
	if (inputarray[1] == xyzJqqcolorUV2[1] and inputarray[2] == xyzJqqcolorUV2[2] and inputarray[4] == xyzJqqcolorUV2[4] and inputarray[5] == xyzJqqcolorUV2[5] and inputarray[6] == xyzJqqcolorUV2[6] and inputarray[7] == xyzJqqcolorUV2[7] and inputarray[12] == xyzJqqcolorUV2[12] ) then (
		result = "xyzJqqcolorUV"
	)	
	
	if (inputarray[1] == xyzUVJqqcolorqqqq[1] and inputarray[2] == xyzUVJqqcolorqqqq[2] and inputarray[4] == xyzUVJqqcolorqqqq[4] and inputarray[5] == xyzUVJqqcolorqqqq[5] and inputarray[6] == xyzUVJqqcolorqqqq[6] and inputarray[7] == xyzUVJqqcolorqqqq[7] and inputarray[12] == xyzUVJqqcolorqqqq[12] ) then (
		result = "xyzUVJqqcolor"
	)
	
	if (inputarray[1] == xyzJqqcolorUVUVqqqq[1] and inputarray[2] == xyzJqqcolorUVUVqqqq[2] and inputarray[4] == xyzJqqcolorUVUVqqqq[4] and inputarray[5] == xyzJqqcolorUVUVqqqq[5] and inputarray[6] == xyzJqqcolorUVUVqqqq[6] and inputarray[7] == xyzJqqcolorUVUVqqqq[7] and inputarray[12] == xyzJqqcolorUVUVqqqq[12] ) then (
		result = "xyzJqqcolorUVUVqqqq"
	)	

	if (inputarray[1] == xyzUVUVJqqcolorqqqq[1] and inputarray[2] == xyzUVUVJqqcolorqqqq[2] and inputarray[4] == xyzUVUVJqqcolorqqqq[4] and inputarray[5] == xyzUVUVJqqcolorqqqq[5] and inputarray[6] == xyzUVUVJqqcolorqqqq[6] and inputarray[7] == xyzUVUVJqqcolorqqqq[7] and inputarray[12] == xyzUVUVJqqcolorqqqq[12] ) then (
		result = "xyzUVUVJqqcolorqqqq"
	)

	if (inputarray[1] == xyzUVqJqqcolorqq[1] and inputarray[2] == xyzUVqJqqcolorqq[2] and inputarray[4] == xyzUVqJqqcolorqq[4] and inputarray[5] == xyzUVqJqqcolorqq[5] and inputarray[6] == xyzUVqJqqcolorqq[6] and inputarray[7] == xyzUVqJqqcolorqq[7] and inputarray[12] == xyzUVqJqqcolorqq[12] ) then (
		result = "xyzUVqJqqcolorqq"
	)
	
	if (inputarray[1] == xyzJqqcolor3[1] and inputarray[2] == xyzJqqcolor3[2] and inputarray[4] == xyzJqqcolor3[4] and inputarray[5] == xyzJqqcolor3[5] and inputarray[6] == xyzJqqcolor3[6] and inputarray[7] == xyzJqqcolor3[7] and inputarray[12] == xyzJqqcolor3[12] ) then (
		result = "xyzJqqcolor"
	)

	if (inputarray[1] == xyzUVUVJqqcolor2[1] and inputarray[2] == xyzUVUVJqqcolor2[2] and inputarray[4] == xyzUVUVJqqcolor2[4] and inputarray[5] == xyzUVUVJqqcolor2[5] and inputarray[6] == xyzUVUVJqqcolor2[6] and inputarray[7] == xyzUVUVJqqcolor2[7] and inputarray[12] == xyzUVUVJqqcolor2[12] ) then (
		result = "xyzUVUVJqqcolor"
	)	
	
	if (inputarray[1] == xyzJqqcolorUV3[1] and inputarray[2] == xyzJqqcolorUV3[2] and inputarray[4] == xyzJqqcolorUV3[4] and inputarray[5] == xyzJqqcolorUV3[5] and inputarray[6] == xyzJqqcolorUV3[6] and inputarray[7] == xyzJqqcolorUV3[7] and inputarray[12] == xyzJqqcolorUV3[12] ) then (
		result = "xyzJqqcolorUV"
	)	
	
	if (inputarray[1] == xyzUVJqqcolor2[1] and inputarray[2] == xyzUVJqqcolor2[2] and inputarray[4] == xyzUVJqqcolor2[4] and inputarray[5] == xyzUVJqqcolor2[5] and inputarray[6] == xyzUVJqqcolor2[6] and inputarray[7] == xyzUVJqqcolor2[7] and inputarray[12] == xyzUVJqqcolor2[12] ) then (
		result = "xyzUVJqqcolor"
	)	
	
	result
)

fn readFVFxyz f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)
)

fn readFVFxyzJqqcolorUV f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
	)
)

fn readFVFxyzJqqcolor f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)
)

fn readFVFxyzJqqcolorUVqqqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		fseek f 16 #seek_cur
	)
)

fn readFVFxyzUVqqJqqcolorqqqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
		fseek f 8 #seek_cur
	)
)

fn readFVFxyzUVqqqqJqqcolor f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
		fseek f 16 #seek_cur
	)
)

fn readFVFxyzUVJqqcolor f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
	)
)

fn readFVFxyzJqqcolorUVqqqqqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		fseek f 24 #seek_cur
	)
)

fn readFVFxyzJqqcolorUVUV f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		fseek f 8 #seek_cur
	)
)

fn readFVFxyzJqqcolorUVUVqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		fseek f 16 #seek_cur
	)
)

fn readFVFxyzUVUVJqqcolor f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
		fseek f 8 #seek_cur
	)
)

fn readFVFxyzUVJqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
	)
)

fn readFVFxyzJqqcolorUVUVqqqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		append varr avert
	)

	--read UV array
	for v = 1 to numverts do
	(
		fseek f 12 #seek_cur
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		fseek f 24 #seek_cur
	)
)

fn readFVFxyzUVUVJqqcolorqqqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
		fseek f 8 #seek_cur
	)
)

fn readFVFxyzUVqJqqcolorqq f offset numverts varr UVWarr =
(
	--go directly to beginning of VB
	fseek f (offset+48) #seek_set

	--read vertex positions
	for v = 1 to numverts do
	(
		avert = [0.,0.,0.]
		avert.x = (readfloat f)
		avert.y = (readfloat f)
		avert.z = (readfloat f)
		aUVW = [readfloat f, -readfloat f, 0.0]
		append UVWarr aUVW
		append varr avert
		fseek f 4 #seek_cur
	)
)
